/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
 * 画面読込時追加処理
 * @param 無し
 * @return 無し
 * @throws 実行時例外
 */
function onLoadExtra() {
	// 項目背景色設定
	setFieldsBgColor(ARY_FIELDS_ID    , COLOR_FIELD_NORMAL);
	setFieldsBgColor(ARY_ERR_FIELDS_ID, COLOR_FIELD_ERROR );
	// 項目長設定
	setMaxLength(PRM_TXT_UNIT_CODE 		, LEN_CODE);
	// 登録/更新判定
	if (MODE == 0) {
		// 読取専用設定
		setReadOnly(PRM_PLT_DELETE  , true);
		// フォーカス設定
		setFocus(PRM_TXT_UNIT_CODE);
	} else if (MODE == 1) {
		// 読取専用設定
		setReadOnly(PRM_TXT_UNIT_CODE  , true);
		setReadOnly(PRM_PLT_START_YEAR  , true);
		setReadOnly(PRM_PLT_START_MONTH  , true);
		/*	2008/11/04	m.yoshida	修正	*/
		setReadOnly(PRM_PLT_START_DAY  , true);
		// フォーカス設定
		setFocus(PRM_PLT_MAIN);
	} else if (MODE == 2) {
		// 登録ボタン利用可否
		setVisibility("btnRegist", false);
		// フォーカス設定
		setFocus(PRM_TXT_UNIT_CODE);
	}
	// 新規登録ボタン利用可否
	if (MODE != 1){
		setObjectVisibility("btnNewData",false);
		setWidth("btnNewData", 0);
	}	
}

/**
 * サーバー通信処理
 * @param 無し
 * @return 無し
 * @throws 実行時例外
 */
function submitForm(objForm) {
	// 入力チェック
	if (validate()) {
		// サーバー通信(入力エラー無の場合)
		if (MODE == 0) {
			doSubmitMessage(objForm, 'S2817', 'QC0001', '');
		} else if (MODE == 1) {
			doSubmitMessage(objForm, 'S2818', 'QC0001', '');
		}
	}
}

/**
 * 入力チェック
 * @param 無し
 * @return チェック結果(true：OK、false：NG)
 * @throws 実行時例外
 */
function validate() {
	// フィールド背景色設定
	setFieldsBgColor(ARY_FIELDS_ID, COLOR_FIELD_NORMAL);
	// 入力チェック
	var aryMessage = new Array();
	checkRequired(PRM_TXT_UNIT_CODE	, NAM_UNIT_CODE	, aryMessage);
	
	checkCode    (PRM_TXT_UNIT_CODE , NAM_UNIT_CODE, aryMessage);
	/*	2008/11/04	m.yoshida	修正	*/	
//	checkDate(PRM_PLT_START_YEAR, PRM_PLT_START_MONTH, PRM_HID_START_DAY,
	checkDate(PRM_PLT_START_YEAR, PRM_PLT_START_MONTH, PRM_PLT_START_DAY,
				NAM_START_DATE, aryMessage);
	
	checkCompare(PRM_PLT_MAIN, PRM_PLT_AGENT, 1, NAM_AGENT, aryMessage);
	
	if (aryMessage.length == 0) {
		return true;
	} else {
		showMessage(aryMessage);
		return false;
	}
}

function checkDate(yyyy, mm, dd,msg,aryMsg) {
	//年月日チェック
	dayMonth = new Array(31,29,31,30,31,30,31,31,30,31,30,31);
	ValidFlag = true;
	yyyy2 = getFormValue(yyyy);
	mm2 = getFormValue(mm);
	dd2 = getFormValue(dd);
	if ((mm2 < 1) || (mm2 > 12)){
		setBgColor(yyyy, COLOR_FIELD_ERROR);
		aryMsg.push(msg + "の月は1--12を入力してください。");
	}
	if ((dd2 < 1) || (dd2 > dayMonth[mm2 - 1])){
		setBgColor(dd, COLOR_FIELD_ERROR);
		aryMsg.push(getMessage("WC0006", msg));
	}
	if (!chkUrudosi(yyyy2) && (mm2 == 2) && (dd2 == 29)){
		setBgColor(dd, COLOR_FIELD_ERROR);
		aryMsg.push(getMessage("WC0006", msg));
	}
}

function chkUrudosi(y) {
	if (((y % 4 == 0) && (y % 100 != 0)) || (y % 400 == 0)) {
		return true;
	}
	return false;
}

